
/**************************************************************************

Author: DFRobot/free

Date:2015-02-07

Description:This is to measure the quality by using the half duplex communication boat.
Water quality parameters including PH, temperature and TDS.
This is the boat and water emission end.

**************************************************************************/

#include <OneWire.h>
#define SensorPin A2            //pH meter Analog output to Arduino Analog Input 0
#define Offset 0.00            //deviation compensate
#define LED 13
#define samplingInterval 10
#define printInterval 60
#define ArrayLenth  40    //times of collection

#define StartConvert 0    //TDS
#define ReadTemperature 1   

const byte numReadings = 20;     //the number of sample times
byte ECsensorPin = A1;  //EC Meter analog output,pin on analog 1
byte DS18B20_Pin = 2; //DS18B20 signal, pin on digital 2
unsigned int AnalogSampleInterval=25;
//unsigned int printInterval=700;
unsigned int tempSampleInterval=850;  //analog sample interval;serial print interval;temperature sample interval
unsigned int readings[numReadings];      // the readings from the analog input
byte index = 0;                  // the index of the current reading
unsigned long AnalogValueTotal = 0;                  // the running total
unsigned int AnalogAverage = 0,averageVoltage=0;                // the average
unsigned long AnalogSampleTime,printTime,tempSampleTime;
float temperature,ECcurrent; 



#define SensorPin A2            //pH meter Analog output to Arduino Analog Input 0
#define Offset 0.00            //deviation compensate
#define LED 13
#define samplingInterval 20
#define printInterval 800
#define ArrayLenth  40    //times of collection
int pHArray[ArrayLenth];   //Store the average value of the sensor feedback
int pHArrayIndex=0; 
 //Temperature chip i/o
OneWire ds(DS18B20_Pin);  // on digital pin 2



/*This class is for the sensor data package transmitted to the receiving end*/
struct mytype {        
  float PH;
  float T;
  long TDS; 
  uint8_t sum;
};
struct mytype data;
void sendD (struct mytype * theData) {
  uint8_t sum = checksum ((uint8_t*)theData, sizeof (struct mytype)-1);

  theData->sum = sum;  
  for (int i=0; i<sizeof(struct mytype);i ++) {
    Serial.write(((uint8_t*)theData)[i]);
    delayMicroseconds (600);
  }
}

uint8_t checksum (uint8_t* theData, uint8_t theLeng){

  uint8_t sum = 0;
  for (int i=0; i< theLeng; i++){
    sum += theData[i];
  }
  return sum;
}




/*The control function of the boat movement*/

int E1 = 5;     //The definition of M1 enable end
int E2 = 6;     //The definition of M2 enable end
int M1 = 4;    //The definition of M1 control terminal
int M2 = 7;    //The definition of M2 control terminal
 
void advance(char a,char b){           //Forward
       analogWrite (E1,a);             //PWM speed control
       digitalWrite(M1,HIGH);    
       analogWrite (E2,b);    
       digitalWrite(M2,HIGH);
}  
void back_off (char a,char b) {          //back
       analogWrite (E1,HIGH);
       digitalWrite(M1,a);   
       analogWrite (E2,HIGH);    
       digitalWrite(M2,b);
}

void turn_R (char a,char b) {           //left
       analogWrite (E1,a);
       digitalWrite(M1,LOW);    
       analogWrite (E2,b);    
       digitalWrite(M2,HIGH);
}
void turn_L (char a,char b) {           //right
       analogWrite (E1,a);
       digitalWrite(M1,HIGH);    
       analogWrite (E2,b);    
       digitalWrite(M2,LOW);
}

void  stopboat  (char a,char b) {          //stop
       analogWrite (E1,a);
       digitalWrite(M1,LOW);   
       analogWrite (E2,b);    
       digitalWrite(M2,LOW);
}





void setup(void) { 

  Serial.begin(19200);      //Set the serial baud rate
  pinMode(LED,OUTPUT);  
  Serial.println("pH meter experiment!");    //Test the serial monitor
  for (byte thisReading = 0; thisReading < numReadings; thisReading++)
    readings[thisReading] = 0;
  TempProcess(StartConvert);   //let the DS18B20 start the convert
  AnalogSampleTime=millis();
  printTime=millis();
  tempSampleTime=millis();

} 

void loop() { 

  delay(40);
   char val = Serial.read();
     Serial.println(val);
      delay(10);
//     if(val!=-1)
          switch(val){
              case 'A'://forward
                     advance (255,255);   //PWM speed control

                     break;
             case 'B'://back
                     back_off (255,255);
                     break;
             case 'L'://left
                     turn_L (255,255);
                     break;       
             case 'R'://right
                     turn_R (255,255);
                     break;
             case 'S'://stop
                    stopboat (255,255);
                    break;
                    
            }  
            delay(10);
            
   TDSPHTread() ;//The sensor read data conversion to the class of the corresponding data
   delay (10);
   sendD (&data);//With the class function to send the sensor data
   delay (10);
  
}



/* The sensor data is transmitted to a class of data transmission */

void TDSPHTread() 

{
  /*
   Every once in a while,sample the analog value and calculate the average.
  */
  if(millis()-AnalogSampleTime>=AnalogSampleInterval)  
  {
    AnalogSampleTime=millis();
     // subtract the last reading:
    AnalogValueTotal = AnalogValueTotal - readings[index];
    // read from the sensor:
    readings[index] = analogRead(ECsensorPin);
    // add the reading to the total:
    AnalogValueTotal = AnalogValueTotal + readings[index];
    // advance to the next position in the array:
    index = index + 1;
    // if we're at the end of the array...
    if (index >= numReadings)
    // ...wrap around to the beginning:
    index = 0;
    // calculate the average:
    AnalogAverage = AnalogValueTotal / numReadings;
  }
  /*
   Every once in a while,MCU read the temperature from the DS18B20 and then let the DS18B20 start the convert.
   Attention:The interval between start the convert and read the temperature should be greater than 750 millisecond,or the temperature is not accurate!
  */
   if(millis()-tempSampleTime>=tempSampleInterval) 
  {
    tempSampleTime=millis();
    temperature = TempProcess(ReadTemperature);  // read the current temperature from the  DS18B20
    TempProcess(StartConvert);                   //after the reading,start the convert for next reading
  }
  
  
   /*here read PH senor   */
  
  static unsigned long samplingTime = millis();
  static unsigned long printTime = millis();
  static float pHValue,voltage;
  if(millis()-samplingTime > samplingInterval)
  {
      pHArray[pHArrayIndex++]=analogRead(SensorPin);
      if(pHArrayIndex==ArrayLenth)pHArrayIndex=0;
      voltage = avergearray(pHArray, ArrayLenth)*5.0/1024;
      pHValue = 3.5*voltage+Offset;
      samplingTime=millis();
  }

   /*
   Every once in a while,print the information on the serial monitor.
  */
  if(millis()-printTime>=printInterval)
  {
    printTime=millis();
    averageVoltage=AnalogAverage*(float)5000/1024;
      data.PH = pHValue  ;
      data.T = temperature;
      data.TDS = averageVoltage;
    
    float TempCoefficient=1.0+0.0185*(temperature-25.0);    //temperature compensation formula: fFinalResult(25^C) = fFinalResult(current)/(1.0+0.0185*(fTP-25.0));
    float CoefficientVolatge=(float)averageVoltage/TempCoefficient;   

  }

}
/*
ch=0,let the DS18B20 start the convert;ch=1,MCU read the current temperature from the DS18B20.
*/
float TempProcess(bool ch)
{
  //returns the temperature from one DS18B20 in DEG Celsius
  static byte data[12];
  static byte addr[8];
  static float TemperatureSum;
  if(!ch){
          if ( !ds.search(addr)) {
//              Serial.println("no more sensors on chain, reset search!");
              ds.reset_search();
              return 0;
          }      
          if ( OneWire::crc8( addr, 7) != addr[7]) {
              Serial.println("CRC is not valid!");
              return 0;
          }        
          if ( addr[0] != 0x10 && addr[0] != 0x28) {
//              Serial.print("Device is not recognized!");
              return 0;
          }      
          ds.reset();
          ds.select(addr);
          ds.write(0x44,1); // start conversion, with parasite power on at the end
  }
  else{  
          byte present = ds.reset();
          ds.select(addr);    
          ds.write(0xBE); // Read Scratchpad            
          for (int i = 0; i < 9; i++) { // we need 9 bytes
            data[i] = ds.read();
          }         
          ds.reset_search();           
          byte MSB = data[1];
          byte LSB = data[0];        
          float tempRead = ((MSB << 8) | LSB); //using two's compliment
          TemperatureSum = tempRead / 16;
    }
          return TemperatureSum;  
}



/*
The PH sensor numerical transformation

*/

double avergearray(int* arr, int number){
  int i;
  int max,min;
  double avg;
  long amount=0;
  if(number<=0){
//    Serial.println("Error number for the array to avraging!/n");
    return 0;
  }
  if(number<5){   //less than 5, calculated directly statistics
    for(i=0;i<number;i++){
      amount+=arr[i];
    }
    avg = amount/number;
    return avg;
  }else{
    if(arr[0]<arr[1]){
      min = arr[0];max=arr[1];
    }
    else{
      min=arr[1];max=arr[0];
    }
    for(i=2;i<number;i++){
      if(arr[i]<min){
        amount+=min;        //arr<min
        min=arr[i];
      }else {
        if(arr[i]>max){
          amount+=max;    //arr>max
          max=arr[i];
        }else{
          amount+=arr[i]; //min<=arr<=max
        }
      }//if
    }//for
    avg = (double)amount/(number-2);
  }//if
  return avg;
}



